"use strict";const PULSE_UUID_KEY="pulse_uuid",PULSE_HEARTBEAT_KEY="pulse_heartbeat",PULSE_HEARTBEAT_MOBILE_KEY="pulse_heartbeat_map",PULSE_PROBABILISTIC_MATCHING_KEY="pulse_confidence",SS_INCOMING_PARAMS="ss_incoming_params";function isObjEmpty(obj){return!obj||0===Object.keys(obj).length}function cleanup(jsonObject,attributes){if(!jsonObject)return jsonObject;const deepCopy=JSON.parse(JSON.stringify(jsonObject));return attributes.forEach((attribute=>delete deepCopy[attribute])),deepCopy}function findObjectPositionByName(jsonArray,key,value){return jsonArray.findIndex((obj=>obj[key]===value))}function getCookieValue(cookie){return cookie.split("=")[1]}function decodeUserAttributes(encoded){try{return JSON.parse(decodeURIComponent(encoded)).UserAttributes}catch(e){return console.error("🤖 Origin Pulse: Error decoding user attributes",e),null}}function findSubValue(attributes){var _a;return(null==(_a=attributes[findObjectPositionByName(attributes,"Name","sub")])?void 0:_a.Value)||null}function setCookie(name,value){const d=new Date;d.setTime(d.getTime()+31536e6);const domain=window.location.hostname.includes("useorigin.com")?"useorigin.com":window.location.hostname;document.cookie=`${name}=${value.replaceAll(";","")};expires=${d.toUTCString()};domain=.${domain};path=/`}function getCookie(name){const match=document.cookie.match(new RegExp("(^| )"+name+"=([^;]+)"));if(match)return match[2]}function saveLocal(key,value){value&&(localStorage.setItem(key,value),setCookie(key,value))}function getPulseCookies(){return getCookie(PULSE_HEARTBEAT_KEY)}function getLastPulse(){try{const lastPulse=localStorage.getItem(PULSE_HEARTBEAT_KEY);return lastPulse?JSON.parse(lastPulse):null}catch(e){return null}}function getPulseUUIDLocalStorage(){return localStorage.getItem(PULSE_UUID_KEY)}function getLastMobilePulse(){try{const mobilePulse=localStorage.getItem(PULSE_HEARTBEAT_MOBILE_KEY);return mobilePulse?JSON.parse(mobilePulse):null}catch(e){return null}}function mobilePulseMatched(){return Number(localStorage.getItem(PULSE_PROBABILISTIC_MATCHING_KEY))}function getPulseUUIDCookies(){return getCookie(PULSE_UUID_KEY)}function syncLocalSession(){!getPulseUUIDLocalStorage()&&getPulseUUIDCookies()&&(saveLocal(PULSE_UUID_KEY,getPulseUUIDCookies()),saveLocal(PULSE_HEARTBEAT_KEY,getPulseCookies()))}function getOriginMemberId(){const memberId=window.localStorage.getItem("origin_member_id");return console.log("🤖 Origin Pulse: getOriginMemberId from localStorage",memberId),memberId||getOriginMemberIdFromCookie()}function getOriginMemberIdFromCookie(cognitoValue="LastAuthUser"){const cookies=document.cookie.split(";").map((cookie=>cookie.trim()));for(const cookie of cookies){if(!cookie.startsWith("CognitoIdentityServiceProvider")||!cookie.includes(cognitoValue))continue;const originMemberID=getCookieValue(cookie);if("LastAuthUser"===cognitoValue){return originMemberID.startsWith("SignInWithApple")||originMemberID.startsWith("Google")?getOriginMemberIdFromCookie("userData"):originMemberID.includes("|")?originMemberID.split("|")[1]:(console.log("🤖 Origin Pulse: getOriginMemberIdFromCookie -> cognitoValue == LastAuthUser",originMemberID),originMemberID)}if("userData"===cognitoValue){const decodedUser=decodeUserAttributes(originMemberID);if(decodedUser){const id=findSubValue(decodedUser);return console.log("🤖 Origin Pulse: getOriginMemberIdFromCookie -> cognitoValue == userData",id),id}return null}}return null}let getRandomValues;const rnds8=new Uint8Array(16);function rng(){if(!getRandomValues&&(getRandomValues="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto),!getRandomValues))throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return getRandomValues(rnds8)}const byteToHex=[];for(let i=0;i<256;++i)byteToHex.push((i+256).toString(16).slice(1));function unsafeStringify(arr,offset=0){return byteToHex[arr[offset+0]]+byteToHex[arr[offset+1]]+byteToHex[arr[offset+2]]+byteToHex[arr[offset+3]]+"-"+byteToHex[arr[offset+4]]+byteToHex[arr[offset+5]]+"-"+byteToHex[arr[offset+6]]+byteToHex[arr[offset+7]]+"-"+byteToHex[arr[offset+8]]+byteToHex[arr[offset+9]]+"-"+byteToHex[arr[offset+10]]+byteToHex[arr[offset+11]]+byteToHex[arr[offset+12]]+byteToHex[arr[offset+13]]+byteToHex[arr[offset+14]]+byteToHex[arr[offset+15]]}const randomUUID="undefined"!=typeof crypto&&crypto.randomUUID&&crypto.randomUUID.bind(crypto),native={randomUUID:randomUUID};function v4(options,buf,offset){if(native.randomUUID&&!buf&&!options)return native.randomUUID();const rnds=(options=options||{}).random||(options.rng||rng)();return rnds[6]=15&rnds[6]|64,rnds[8]=63&rnds[8]|128,unsafeStringify(rnds)}function camelToSnake(str){return str.replace(/[A-Z]/g,(letter=>`_${letter.toLowerCase()}`))}function convertKeysToSnakeCase(obj){if(Array.isArray(obj))return obj.map((item=>convertKeysToSnakeCase(item)));if(null!==obj&&"object"==typeof obj){const newObj={};return Object.keys(obj).forEach((key=>{newObj[camelToSnake(key)]=convertKeysToSnakeCase(obj[key])})),newObj}return obj}function snakeToCamel(str){return str.replace(/(_\w)/g,(matches=>matches[1].toUpperCase()))}function convertKeysToCamelCase(obj){if(Array.isArray(obj))return obj.map((item=>convertKeysToCamelCase(item)));if(null!==obj&&"object"==typeof obj){const newObj={};return Object.keys(obj).forEach((key=>{newObj[snakeToCamel(key)]=convertKeysToCamelCase(obj[key])})),newObj}return obj}const PULSE_API_URL="https://api.useorigin.com/pulse";var PulseEndpoints=(PulseEndpoints2=>(PulseEndpoints2.MATCH="/heartbeat/match",PulseEndpoints2.PULSE="/heartbeat",PulseEndpoints2))(PulseEndpoints||{});function getHeaders(){const headers=new Headers;return headers.append("Content-Type","application/json"),headers.append("accept","application/json"),headers}function getRequestOptions(method,body){const snakeCaseBody=convertKeysToSnakeCase(body);return{method:method,headers:getHeaders(),body:JSON.stringify(snakeCaseBody),redirect:"follow"}}async function pulseRequest(pulseEvent){const requestUrl=`${PULSE_API_URL}${PulseEndpoints.PULSE}`,requestOptions=getRequestOptions("POST",pulseEvent);console.log("🤖 BE: /heartbeat");try{const response=await fetch(requestUrl,requestOptions);if(!response.ok)throw new Error(`🤖[Pulse]: Error sending pulse event. Status: ${response.status}`);const result=await response.text();console.log(result)}catch(error){console.error(error)}}async function matchRequest(pulse2){const requestUrl=`${PULSE_API_URL}${PulseEndpoints.MATCH}`,requestOptions=getRequestOptions("POST",{pulse:pulse2});console.log("🤖 BE: /heartbeat/match");try{const response=await fetch(requestUrl,requestOptions);if(!response.ok)throw new Error(`🤖[Pulse]: Error sending pulse. Status: ${response.status}`);const camelCaseResult=convertKeysToCamelCase(await response.json());return console.log(camelCaseResult),camelCaseResult}catch(error){return console.error(error),null}}var IpAddressApis=(IpAddressApis2=>(IpAddressApis2.IPIFY="ipify",IpAddressApis2.ICANHAZIP="icanhazip",IpAddressApis2.IFCONFIG="ifconfig",IpAddressApis2))(IpAddressApis||{});const IPIFY_URL="https://api.ipify.org?format=json",ICANHAZIP_URL="https://icanhazip.com/",IFCONFIG_URL="https://ifconfig.me/ip",IPSTACK_URL="https://api.ipstack.com/",IPSTACK_ACCESS_KEY="b5b123a34b378c793850596ff1b0a565";async function getIPAddress(source=IpAddressApis.IPIFY){if(source===IpAddressApis.IPIFY)try{const response=await fetch(IPIFY_URL);if(!response.ok)return getIPAddress(IpAddressApis.ICANHAZIP);const data=await response.json();return data&&"undefined"!==data?data.ip:getIPAddress(IpAddressApis.ICANHAZIP)}catch(error){return getIPAddress(IpAddressApis.ICANHAZIP)}if(source===IpAddressApis.ICANHAZIP)try{const response=await fetch(ICANHAZIP_URL);if(!response.ok)return getIPAddress(IpAddressApis.IFCONFIG);const data=await response.text();return data&&"undefined"!==data?data.trim():getIPAddress(IpAddressApis.IFCONFIG)}catch(error){return getIPAddress(IpAddressApis.IFCONFIG)}if(source===IpAddressApis.IFCONFIG)try{const response=await fetch(IFCONFIG_URL);if(!response.ok)return null;return(await response.json()).query}catch(error){return null}return null}async function getLocationDetails(ipAddress){try{const response=await fetch(`${IPSTACK_URL}${ipAddress}?access_key=${IPSTACK_ACCESS_KEY}`);if(!response.ok)return null;const data=await response.json();return{countryName:data.country_name,countryCode:data.country_code,city:data.city,zip:data.zip}}catch(error){return null}}function getGenericUTM(){const urlParams=new URLSearchParams(window.location.search),pulseMarkers={};return urlParams.forEach(((value,key)=>{key.startsWith("utm_")&&(pulseMarkers[key]=value.split("%")[0])})),isObjEmpty(pulseMarkers)?null:pulseMarkers}function getDefaultGenericUTM(){const incomingParams=localStorage.getItem(SS_INCOMING_PARAMS);try{const urlParams=incomingParams?JSON.parse(incomingParams):null;if(!urlParams)return null;const lastUTM=cleanup(urlParams[0],["af_ss_exp_at"]);return isObjEmpty(lastUTM)||-1===JSON.stringify(lastUTM).indexOf("utm")?null:lastUTM}catch(e){return null}}function isMobileApp(){return navigator.userAgent.includes("OriginNative")}function getDeviceInfo(){var _a;return{browser:navigator.userAgent,os:(null==(_a=navigator.userAgentData)?void 0:_a.platform)||navigator.platform,language:navigator.language,screenResolution:`${screen.width}x${screen.height}`,deviceType:/Mobi|Android/i.test(navigator.userAgent)?"Mobile":"Desktop"}}function getCurrentUTCTimestamp(){return(new Date).toISOString()}function getLastOriginMemberID(){const lastPulse=getLastPulse();return lastPulse&&lastPulse.originMemberId?lastPulse.originMemberId:null}function isAnonymousPulse(pulse2){return null==pulse2||void 0===pulse2.originMemberId||null===pulse2.originMemberId||""===pulse2.originMemberId}function getPulseUUID(){let pulseUUID=getPulseUUIDLocalStorage();return pulseUUID||(pulseUUID=v4(),saveLocal(PULSE_UUID_KEY,pulseUUID)),pulseUUID}async function inferProbabilisticMatching(){if(mobilePulseMatched())return;const pulse2=(await pulseFactory())[0],pulseMatch=await matchRequest(pulse2);if(isObjEmpty(pulseMatch))return void saveLocal(PULSE_PROBABILISTIC_MATCHING_KEY,"0");const trimmedPulse={uuid:null==pulseMatch?void 0:pulseMatch.pulse.uuid,originMemberId:null==pulseMatch?void 0:pulseMatch.pulse.originMemberId,timestampUtc:null==pulseMatch?void 0:pulseMatch.pulse.timestampUtc},confidence=(null==pulseMatch?void 0:pulseMatch.confidence)??0,uuid=(null==pulseMatch?void 0:pulseMatch.pulse.uuid)??"";saveLocal(PULSE_PROBABILISTIC_MATCHING_KEY,confidence.toString()),saveLocal(PULSE_UUID_KEY,uuid),saveLocal(PULSE_HEARTBEAT_KEY,JSON.stringify(trimmedPulse))}async function pulseAPI(pulse2,lastPulse){const pulseEvent={pulse:pulse2,eventName:isAnonymousPulse(lastPulse)&&pulse2.originMemberId?"authentication":"page_view",eventDetails:`${location.protocol}//${location.host+location.pathname}`},attributionMatching=mobilePulseMatched();attributionMatching&&0!==attributionMatching&&(pulseEvent.confidence=attributionMatching),await pulseRequest(pulseEvent)}async function pulseAPIMobile(pulse2,lastPulse){var _a;const attributionMatching=mobilePulseMatched();if(!attributionMatching||0===attributionMatching)return;const pulseEvent={pulse:pulse2,eventName:isAnonymousPulse(lastPulse)&&pulse2.originMemberId?"authentication":"mobile_app_view",eventDetails:(null==(_a=navigator.userAgentData)?void 0:_a.platform)||navigator.platform,confidence:attributionMatching};await pulseRequest(pulseEvent)}async function pulseFactory(){const lastPulse=getLastPulse(),ipAddress=await getIPAddress(),location2=await getLocationDetails(ipAddress),genericUtm=getGenericUTM()?getGenericUTM():getDefaultGenericUTM(),originMemberId=getOriginMemberId()?getOriginMemberId():getLastOriginMemberID();return[{uuid:getPulseUUID(),originMemberId:originMemberId,genericUtm:genericUtm||(lastPulse?lastPulse.genericUtm:null),ipAddress:ipAddress,location:location2,deviceDetails:getDeviceInfo(),timestampUtc:getCurrentUTCTimestamp()},lastPulse]}async function pulse(keyId){const[pulse2,lastPulse]=await pulseFactory(),trimmedPulse={uuid:pulse2.uuid,originMemberId:pulse2.originMemberId,timestampUtc:pulse2.timestampUtc};saveLocal(keyId,JSON.stringify(trimmedPulse)),isMobileApp()?await pulseAPIMobile(pulse2,lastPulse):await pulseAPI(pulse2,lastPulse)}async function runPulse(){console.log("🤖 Origin Pulse"),syncLocalSession(),isMobileApp()?getLastMobilePulse()?mobilePulseMatched()&&isAnonymousPulse(getLastPulse())&&getOriginMemberId()&&await pulse(PULSE_HEARTBEAT_KEY):(await inferProbabilisticMatching(),await pulse(PULSE_HEARTBEAT_MOBILE_KEY)):(await inferProbabilisticMatching(),(getGenericUTM()||getLastPulse()&&isAnonymousPulse(getLastPulse())&&getOriginMemberId())&&await pulse(PULSE_HEARTBEAT_KEY)),console.log("🤖 Pulse finished")}async function runPulseOnRouteChange(){await runPulse();const originalPushState=history.pushState.bind(history),originalReplaceState=history.replaceState.bind(history);history.pushState=(state,title,url)=>{originalPushState(state,title,url),window.dispatchEvent(new Event("locationchange"))},history.replaceState=(state,title,url)=>{originalReplaceState(state,title,url),window.dispatchEvent(new Event("locationchange"))},window.addEventListener("popstate",(()=>{window.dispatchEvent(new Event("locationchange"))})),window.addEventListener("locationchange",(async()=>{await runPulse()}))}let PULSE_INITED=!1;async function initPulse(callback){await runPulseOnRouteChange(),"function"==typeof callback&&(null==callback||callback(),console.log("🤖 Pulse callback executed")),PULSE_INITED=!0}window.initPulse=initPulse,(async()=>{PULSE_INITED||await runPulseOnRouteChange()})();
